#define Uses_TApplication
#define Uses_TStatusLine
#define Uses_TStatusDef
#define Uses_TStatusItem
#define Uses_TDialog
#define Uses_TInputLine
#define Uses_MsgBox
#define Uses_TEvent
#define Uses_TKeys
#define Uses_TDeskTop
#include <tv.h>

const cmLoseFocus = 30;

class TTest : public TInputLine
	{
	public:

		TTest(const TRect& bounds, int aMaxLen) :
			TInputLine(bounds, aMaxLen)
			{
//			setData("Test");
			}

		virtual Boolean valid(ushort command)
			{
			if(command == cmLoseFocus && *data == EOS)
				{
				messageBox("Can't leave with empty line!", mfError|mfOKButton);
				return False;
				}
			else
				return TInputLine::valid(command);
			}
	};

const cmTest = 100;

class TApp : public TApplication
	{
	public:

		TApp() : TProgInit(initStatusLine, initMenuBar, initDeskTop)
			{
			enableCommand(cmTest);
			enableCommand(cmResize);
			}

		static TStatusLine* initStatusLine(TRect r)
			{
			r.a.y = r.b.y-1;
			return new TStatusLine(r,
				*new TStatusDef(0, 0xFFFF)+
					*new TStatusItem("~Alt-X~ Exit", kbAltX, cmQuit)+
					*new TStatusItem("~Alt-T~ Test", kbAltT, cmTest)+
					*new TStatusItem("~Alt-R~ Resize", kbAltR, cmResize)
				);
			}

		virtual void handleEvent(TEvent& event)
			{
			TApplication::handleEvent(event);

			if(event.what == evCommand && event.message.command == cmTest)
				{
				TDialog* dlg = new TDialog(TRect(0,0,16,8), "Test");
				dlg->options |= ofCentered;
				dlg->insert(new TTest(TRect(3,3,13,4), 7));
				dlg->insert(new TTest(TRect(3,5,13,6), 7));
				if(validView(dlg) != 0)
					{
					deskTop->execView(dlg);
					destroy(dlg);
					}
				clearEvent(event);
				}
			}
	};

int main()
	{
	TApp app;

	if(app.valid(cmValid))
		app.run();
	app.shutDown();

	return 0;
	}
